## kmymoney 5.2.1

=== doc/CMakeLists.txt ===
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kmymoney)
kdoctools_create_manpage(man-kmymoney.1.docbook 1 INSTALL_DESTINATION ${KDE_INSTALL_MANDIR})

=== kmymoney/converter/CMakeLists.txt ===
if(BUILD_TESTING)
  add_subdirectory( tests )
endif()

set (libconverter_a_SOURCES
  mymoneystatementreader.cpp
  transactionmatchfinder.cpp
  existingtransactionmatchfinder.cpp
  scheduledtransactionmatchfinder.cpp
  ../widgets/kmymoneymoneyvalidator.cpp
)

add_library(converter STATIC ${libconverter_a_SOURCES})

# TODO: clean dependencies
target_link_libraries(converter
  PUBLIC
    KF${QT_MAJOR_VERSION}::Service
    KF${QT_MAJOR_VERSION}::XmlGui
    KF${QT_MAJOR_VERSION}::Completion
    KF${QT_MAJOR_VERSION}::TextWidgets
    KF${QT_MAJOR_VERSION}::WidgetsAddons
    Alkimia::alkimia
    KF${QT_MAJOR_VERSION}::KIOWidgets
    kmm_csvimportercore
    kmm_base_dialogs
    kmm_models
  PRIVATE
    KF${QT_MAJOR_VERSION}::I18n
    kmymoney_common
    newaccountwizard
)

# we rely on some dialogs to be generated
# add_dependencies(converter)

########### install files ###############

=== kmymoney/menus/CMakeLists.txt ===
set (menus_SOURCES
  menuenums.cpp
)

add_library(kmm_menus ${menus_SOURCES})
generate_export_header(kmm_menus)
target_link_libraries(kmm_menus PRIVATE Qt::Widgets Qt::Core)

set_target_properties(kmm_menus PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)

install(TARGETS kmm_menus
  ${INSTALL_TARGETS_DEFAULT_ARGS} )

=== kmymoney/misc/CMakeLists.txt ===
install(PROGRAMS financequote.pl
        DESTINATION ${KDE_INSTALL_DATADIR}/kmymoney/misc)

set( kmm_utils_validators_SRCS
  charvalidator.cpp
  validators.cpp
)

set( kmm_url_SRCS
  kmmurl.cpp
)

set( kmm_textbrowser_SRCS
  kmmtextbrowser.cpp
)
set( kmm_webconnect_SRCS
  webconnect.cpp
  kmmonlinequotesprofilemanager.cpp
)

set ( kmm_keychain_SRCS
  kmmkeychain.cpp
)

set ( kmm_yesno_SRCS
  kmmyesno.cpp
)

if( "${HAVE_UNISTD_H}" AND "${HAVE_PWD_H}" )
  set( kmm_utils_platformtools_SRCS
    platformtools_gnu.cpp
  )
elseif( "${HAVE_WINDOWS_H}" AND "${HAVE_LMCONS_H}" AND "${HAVE_PROCESS_H}" )
  set( kmm_utils_platformtools_SRCS
    platformtools_nognu.cpp
  )
else()
  message(FATAL_ERROR "make sure either windows.h and lmcons.h (on msvc platforms) or unistd.h and pwd.h (on other platforms) are present.")
endif()

set( kmm_utils_validators_HEADER
  charvalidator.h
  validators.h
)

set( kmm_webconnect_HEADER
  webpricequote.h
  webconnect.h
)

set ( kmm_keychain_HEADER
  kmmkeychain.h
)

set( kmm_utils_platformtools_HEADER
  platformtools.h
)

set( kmm_url_HEADER
  kmmurl.h
)

set( kmm_textbrowser_HEADER
  kmmtextbrowser.h
)

set( kmm_printer_SRCS
  kmm_printer.cpp
)

set( kmm_selections_SRCS
  selectedobjects.cpp
)

set( kmm_menuactionexchanger_SRCS
  kmm_menuactionexchanger.cpp
)

set( kmm_kcmodule_SRCS
  kmm_kcmodule.h
)

set( kmm_codec_SRCS
  kmm_codec.cpp
)

add_library(kmm_utils_validators STATIC ${kmm_utils_validators_SRCS})
add_library(kmm_utils_platformtools STATIC ${kmm_utils_platformtools_SRCS})
add_library(kmm_url STATIC ${kmm_url_SRCS})
add_library(kmm_textbrowser STATIC ${kmm_textbrowser_SRCS})
add_library(kmm_webconnect ${kmm_webconnect_SRCS})
add_library(kmm_keychain ${kmm_keychain_SRCS})
add_library(kmm_printer ${kmm_printer_SRCS})
add_library(kmm_selections ${kmm_selections_SRCS})
add_library(kmm_yesno ${kmm_yesno_SRCS})
add_library(kmm_menuactionexchanger ${kmm_menuactionexchanger_SRCS})
add_library(kmm_kcmodule STATIC ${kmm_kcmodule_SRCS})
add_library(kmm_codec ${kmm_codec_SRCS})

target_link_libraries( kmm_utils_validators
  PUBLIC
  Qt::Core
  Qt::Gui
)

target_link_libraries( kmm_webconnect
  PUBLIC
    Qt::Core
    Qt::Network
    KF${QT_MAJOR_VERSION}::ConfigCore
    KF${QT_MAJOR_VERSION}::Service
    KF${QT_MAJOR_VERSION}::Codecs
    KF${QT_MAJOR_VERSION}::KIOCore
    KF${QT_MAJOR_VERSION}::KIOWidgets
    Alkimia::alkimia
    kmm_mymoney
    kmm_csvimportercore
  PRIVATE
    KF${QT_MAJOR_VERSION}::I18n
)

target_link_libraries( kmm_keychain
  PUBLIC
  Qt::Core
  qt${QT_MAJOR_VERSION}keychain
)

target_link_libraries( kmm_utils_platformtools
  PUBLIC
  Qt::Core
)

target_link_libraries( kmm_url
  PUBLIC
  Qt::Core
)

target_link_libraries( kmm_textbrowser
  PUBLIC
  Qt::Core
  Qt::Widgets
)

target_link_libraries(kmm_printer
  PUBLIC
  Qt::Core
  Qt::PrintSupport
)

target_link_libraries( kmm_selections
  PUBLIC
  Qt::Core
)

target_link_libraries(kmm_yesno
  PRIVATE
    KF${QT_MAJOR_VERSION}::I18n
    KF${QT_MAJOR_VERSION}::WidgetsAddons
)

target_link_libraries(kmm_menuactionexchanger
  PUBLIC
    Qt::Core
    Qt::Widgets
)

target_link_libraries(kmm_kcmodule
  PUBLIC
    Qt::Core
    Qt::Widgets
    KF${QT_MAJOR_VERSION}::KCMUtils
)

target_link_libraries(kmm_codec
  PUBLIC
    Qt::Core
    Qt::Widgets
)

set_target_properties(kmm_selections PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)
generate_export_header(kmm_selections)

set_target_properties(kmm_printer PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)
generate_export_header(kmm_printer)

set_target_properties(kmm_webconnect PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)
generate_export_header(kmm_webconnect)

set_target_properties(kmm_keychain PROPERTIES
        VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)
generate_export_header(kmm_keychain)

set_target_properties(kmm_yesno PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)
generate_export_header(kmm_yesno)

set_target_properties(kmm_menuactionexchanger PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)
generate_export_header(kmm_menuactionexchanger)

set_target_properties(kmm_kcmodule PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)

set_target_properties(kmm_codec PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)
generate_export_header(kmm_codec)

set( kmm_gpgfile_SRCS
kgpgfile.cpp
)
add_library(kmm_gpgfile ${kmm_gpgfile_SRCS})
target_link_libraries(kmm_gpgfile
    PUBLIC
        Qt::Core
        ${GPG_LIBRARY}
)

set_target_properties(kmm_gpgfile PROPERTIES
    VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)
generate_export_header(kmm_gpgfile)

install(TARGETS kmm_gpgfile ${INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kmm_gpgfile_export.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kmymoney COMPONENT Devel)

install(TARGETS
        kmm_printer
        kmm_webconnect
        kmm_keychain
        kmm_selections
        kmm_yesno
        kmm_menuactionexchanger
	kmm_codec
        ${INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/kmm_printer_export.h
        ${CMAKE_CURRENT_BINARY_DIR}/kmm_selections_export.h
        ${CMAKE_CURRENT_BINARY_DIR}/kmm_webconnect_export.h
        ${CMAKE_CURRENT_BINARY_DIR}/kmm_keychain_export.h
        ${CMAKE_CURRENT_BINARY_DIR}/kmm_yesno_export.h
        ${CMAKE_CURRENT_BINARY_DIR}/kmm_menuactionexchanger_export.h
  DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kmymoney COMPONENT Devel)

=== kmymoney/mymoney/CMakeLists.txt ===
add_subdirectory( xmlhelper )
add_subdirectory( storage )
add_subdirectory( payeeidentifier )

########### next target ###############

set(kmm_mymoney_LIB_SRCS
  mymoneymoney.cpp mymoneyfinancialcalculator.cpp
  mymoneytransactionfilter.cpp
  mymoneyfile.cpp mymoneykeyvaluecontainer.cpp
  mymoneyobject.cpp
  mymoneypayeeidentifiercontainer.cpp
  mymoneysplit.cpp mymoneyinstitution.cpp
  mymoneyinvesttransaction.cpp mymoneyutils.cpp
  mymoneysecurity.cpp mymoneytransaction.cpp mymoneyschedule.cpp
  mymoneypayee.cpp mymoneytracer.cpp
  mymoneytag.cpp
  mymoneycategory.cpp
  mymoneycostcenter.cpp
  mymoneyaccount.cpp mymoneyaccountloan.cpp
  mymoneyreport.cpp mymoneystatement.cpp mymoneyprice.cpp mymoneybudget.cpp
  mymoneyforecast.cpp
  mymoneyqifprofile.cpp
  mymoneytemplate.cpp
  mymoneybalancecache.cpp
  mymoneyfactory.cpp
  onlinejob.cpp
  onlinejobadministration.cpp
  onlinejobmessage.cpp
  onlinejobfolder.cpp
  onlinepricemodel.cpp
  mymoneycontact.cpp
  payeeidentifiermodel.cpp
  statusmodel.cpp
  splitmodel.cpp
  )

  # storage_a_SOURCES cannot be set in storage directory on MS Windows
  # because, while building kmm_storage, linker reports many undefined symbols
  # which are in fact available in kmm_mymoney
  set(storage_a_SOURCES
    ./storage/imymoneystorageformat.cpp
    ./storage/mymoneymodelbase.cpp
    ./storage/payeesmodel.cpp
    ./storage/costcentermodel.cpp
    ./storage/schedulesmodel.cpp
    ./storage/tagsmodel.cpp
    ./storage/securitiesmodel.cpp
    ./storage/budgetsmodel.cpp
    ./storage/accountsmodel.cpp
    ./storage/institutionsmodel.cpp
    ./storage/journalmodel.cpp
    ./storage/pricemodel.cpp
    ./storage/parametersmodel.cpp
    ./storage/onlinejobsmodel.cpp
    ./storage/reportsmodel.cpp
    ./storage/reconciliationmodel.cpp
    ./storage/specialdatesmodel.cpp
    ./storage/schedulesjournalmodel.cpp
    ./storage/templatesmodel.cpp
    )

  set(onlineTask_a_SOURCES
  ./onlinetasks/sepa/sepaonlinetransferimpl.cpp
  ./onlinetasks/sepa/sepaonlinetransfer.cpp
  ./onlinetasks/unavailabletask/tasks/unavailabletask.cpp
  )

  set(xmlhelper_a_SOURCES
  ./xmlhelper/xmlstoragehelper.cpp
  )

  # NOTE: this payeeIdentifier and its cmake file cannot be used as a template
  # This payeeIdentifier must be linked with payeeIdentifierLoader because it
  # is a fallback if something failed during loading of plugins (for xml files only)
  set(payeeidentifier_a_SOURCES
  ./payeeidentifier/ibanbic/ibanbic.cpp
  ./payeeidentifier/nationalaccount/nationalaccount.cpp
  ./payeeidentifier/unavailableplugin/unavailableplugin.cpp
  )

list(APPEND storage_a_SOURCES $<$<OR:$<CONFIG:Debug>,$<CONFIG:DebugFull>,$<CONFIG:DebugKMM>>: ./storage/mymoneystoragedump.cpp>)
list(APPEND kmm_mymoney_LIB_SRCS ${storage_a_SOURCES})
list(APPEND kmm_mymoney_LIB_SRCS ${onlineTask_a_SOURCES})
list(APPEND kmm_mymoney_LIB_SRCS ${payeeidentifier_a_SOURCES})
list(APPEND kmm_mymoney_LIB_SRCS ${xmlhelper_a_SOURCES})

set(mymoney_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/kmm_mymoney_export.h
  mymoneyobject.h mymoneyaccount.h mymoneycategory.h mymoneyexception.h
  mymoneyfile.h mymoneyfinancialcalculator.h mymoneyinstitution.h
  mymoneyinvesttransaction.h mymoneykeyvaluecontainer.h mymoneymoney.h
  mymoneypayee.h mymoneytag.h mymoneyprice.h mymoneyreport.h
  mymoneyschedule.h mymoneysecurity.h mymoneysplit.h mymoneystatement.h
  mymoneytransactionfilter.h mymoneytransaction.h
  mymoneyutils.h mymoneybudget.h mymoneyforecast.h
  imymoneyprocessingcalendar.h
  mymoneycostcenter.h
  mymoneyenums.h
  mymoneyqifprofile.h
  mymoneytemplate.h
  mymoneyunittestable.h
  mymoneypayeeidentifiercontainer.h
  onlinejob.h
  onlinejobtyped.h
  onlinejobmessage.h
  onlinejobfolder.h
  )

add_library(kmm_mymoney ${kmm_mymoney_LIB_SRCS})

if (USE_MODELTEST)
  target_compile_definitions(kmm_mymoney PRIVATE -DKMM_MODELTEST)
endif()

generate_export_header(kmm_mymoney BASE_NAME kmm_mymoney)

target_link_libraries(kmm_mymoney
                      PUBLIC
                      kmm_icons
                      Qt::Xml
                      Qt::Core
                      Qt::Gui
                      KF${QT_MAJOR_VERSION}::Service
                      KF${QT_MAJOR_VERSION}::I18n
                      KF${QT_MAJOR_VERSION}::ItemModels
                      KF${QT_MAJOR_VERSION}::ConfigCore
                      $<$<BOOL:${BUILD_WITH_QT6}>:KF${QT_MAJOR_VERSION}::CoreAddons>
                      Alkimia::alkimia
                      kmm_payeeidentifier
                      kmm_plugin
                      # TODO: fix this
                      KF${QT_MAJOR_VERSION}::XmlGui
                      PRIVATE
                      kmm_keychain
                      onlinetask_interfaces
                      $<$<BOOL:${USE_MODELTEST}>:Qt::Test>
)

if(ENABLE_ADDRESSBOOK)
target_link_libraries(kmm_mymoney PUBLIC ${PIMPREFIX}::IdentityManagement ${PIMPREFIX}::AkonadiCore KF${QT_MAJOR_VERSION}::Contacts)
endif()

set_target_properties(kmm_mymoney PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

# create gdb pretty printer in build directory
add_custom_command(TARGET kmm_mymoney POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/kmm_mymoney-gdb.py" "$<TARGET_FILE_DIR:kmm_mymoney>/$<TARGET_FILE_NAME:kmm_mymoney>-gdb.py"
)

########### install files ###############

install(TARGETS kmm_mymoney
  ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES ${mymoney_HEADERS}
  DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kmymoney COMPONENT Devel)

############## tests ####################

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== kmymoney/settings/CMakeLists.txt ===

kconfig_add_kcfg_files( kmm_settings_SRCS kmymoneysettings.kcfgc )

add_library(kmm_settings ${kmm_settings_SRCS})

set_target_properties(kmm_settings PROPERTIES
      VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR} )

generate_export_header(kmm_settings BASE_NAME kmm_settings)

target_link_libraries(kmm_settings
                      PRIVATE
                      KF${QT_MAJOR_VERSION}::ConfigWidgets)

set(kmm_settings_HEADERS
    ${CMAKE_CURRENT_BINARY_DIR}/kmm_settings_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/kmymoneysettings.h
    kmymoneysettings_addons.h)


install(TARGETS kmm_settings
  ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES kmymoney.kcfg
  DESTINATION ${KDE_INSTALL_KCFGDIR}
  )
install(FILES kmymoney.upd
  DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR}
  )

install(FILES ${kmm_settings_HEADERS}
  DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kmymoney COMPONENT Devel)

=== kmymoney/tests/CMakeLists.txt ===
include(ECMAddTests)

file(GLOB tests_sources "*-test.cpp")
kmm_add_tests(${tests_sources}
  NAME_PREFIX
    "kmymoney-"
  LINK_LIBRARIES
    Qt::Core
    Qt::Test
    kmm_testutils
    kmymoney_common
)

add_library(kmm_testutilities STATIC
  testutilities.cpp
)
target_link_libraries(kmm_testutilities
  PUBLIC
    Qt::Core
  PRIVATE
    mymoneystoragexml
    xmlstoragehelper
)

=== kmymoney/widgets/CMakeLists.txt ===

########### create links ###############
set(kmm_widgets_HEADERS
  amountedit.h
  amountvalidator.h
  creditdebitedit.h
  kaccounttemplateselector.h
  kguiutils.h
  kmymoneyaccountcombo.h
  kmymoneyaccountcompletion.h
  kmymoneyaccountselector.h
  kmymoneycategory.h
  kmymoneycombo.h
  kmymoneycompletion.h
  kmymoneycurrencyselector.h
  kmymoneydateedit.h
  kmymoneylineedit.h
  kmymoneymvccombo.h
  kmymoneyselector.h
  kmymoneyvalidationfeedback.h
  onlinejobmessagesview.h
  popuppositioner.h
  )

########### Shared widget library ###########
set(kmm_base_widgets_SOURCES
  amountedit.cpp
  amountvalidator.cpp
  columnselector.cpp
  creditdebitedit.cpp
  kaccounttemplateselector.cpp
  kguiutils.cpp
  kmmsearchwidget.cpp
  kmymoneyaccountcombo.cpp
  kmymoneyaccountcompletion.cpp
  kmymoneyaccountselector.cpp
  kmymoneyaccounttreeview.cpp
  kmymoneyactivitycombo.cpp
  kmymoneycalculator.cpp
  kmymoneycategory.cpp
  kmymoneycombo.cpp
  kmymoneycompletion.cpp
  kmymoneycurrencyselector.cpp
  kmymoneydateedit.cpp
  kmymoneyfrequencycombo.cpp
  kmymoneygeneralcombo.cpp
  kmymoneylineedit.cpp
  kmymoneymoneyvalidator.cpp
  kmymoneymvccombo.cpp
  kmymoneyoccurrencecombo.cpp
  kmymoneyoccurrenceperiodcombo.cpp
  kmymoneypayeecombo.cpp
  kmymoneyperiodcombo.cpp
  kmymoneyreconcilecombo.cpp
  kmymoneyselector.cpp
  kmymoneytextedit.cpp
  kmymoneytextedithighlighter.cpp
  kmymoneyvalidationfeedback.cpp
  ktagcontainer.cpp
  ktaglabel.cpp
  passwordtoggle.cpp
  passstore.cpp
  popuppositioner.cpp
  styleditemdelegateforwarder.cpp
  kmymoneytreeview.cpp
  taborder.cpp
  transactionsortoption.cpp
  widgethintframe.cpp
  onlinesourcedelegate.cpp
  )

set(kmm_widgets_SOURCES
  budgetviewproxymodel.cpp
  daterangedlg.cpp
  kmymoneybriefschedule.cpp
  kmymoneyviewbase.cpp
  kpricetreeitem.cpp
  ktransactionfilter.cpp
  ktreewidgetfilterlinewidget.cpp
  onlinejobmessagesview.cpp
  )

set(nationalAccountWidget_SOURCES
  ./payeeidentifier/nationalaccount/nationalaccountedit.cpp
  ./payeeidentifier/nationalaccount/nationalaccountdelegate.cpp
)

set(nationalAccountWidget_HEADERS
  ./payeeidentifier/nationalaccount/nationalaccountdelegate.h
  ./payeeidentifier/nationalaccount/nationalaccountedit.h
)

set(IBANBICWidget_SOURCES
  ./payeeidentifier/ibanbic/kibanlineedit.cpp
  ./payeeidentifier/ibanbic/kbicedit.cpp
  ./payeeidentifier/ibanbic/ibanvalidator.cpp
  ./payeeidentifier/ibanbic/bicvalidator.cpp
  ./payeeidentifier/ibanbic/ibanbicitemdelegate.cpp
  ./payeeidentifier/ibanbic/ibanbicitemedit.cpp
)

set(IBANBICWidget_HEADERS
  ./payeeidentifier/ibanbic/kibanlineedit.h
  ./payeeidentifier/ibanbic/kbicedit.h
  ./payeeidentifier/ibanbic/ibanvalidator.h
  ./payeeidentifier/ibanbic/bicvalidator.h
  ./payeeidentifier/ibanbic/ibanbicitemdelegate.h
)

list(APPEND kmm_base_widgets_SOURCES ${nationalAccountWidget_SOURCES})
list(APPEND kmm_widgets_HEADERS ${nationalAccountWidget_HEADERS})

list(APPEND kmm_base_widgets_SOURCES ${IBANBICWidget_SOURCES})
list(APPEND kmm_widgets_HEADERS ${IBANBICWidget_HEADERS})

ki18n_wrap_ui(kmm_base_widgets_SOURCES
  creditdebitedit.ui
  kaccounttemplateselector.ui
  kmmsearchwidget.ui
  kmymoneyvalidationfeedback.ui
  ./payeeidentifier/nationalaccount/nationalaccountedit.ui
  ./payeeidentifier/ibanbic/ibanbicitemedit.ui
  transactionsortoption.ui
)


ki18n_wrap_ui(kmm_widgets_SOURCES
  kmymoneybriefschedule.ui
  onlinejobmessagesview.ui
  daterangedlg.ui
  ktransactionfilter.ui
)

add_library(kmm_base_widgets ${kmm_base_widgets_SOURCES})

target_link_libraries(kmm_base_widgets PUBLIC
  KF${QT_MAJOR_VERSION}::Completion
  KF${QT_MAJOR_VERSION}::Notifications
  KF${QT_MAJOR_VERSION}::TextWidgets
  Alkimia::alkimia
  kmm_selections
  kmm_mymoney
  kmm_settings
  kmm_models
  $<$<BOOL:${ENABLE_GPG}>:kmm_gpgfile>
)

set_target_properties(kmm_base_widgets PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)

generate_export_header(kmm_base_widgets BASE_NAME kmm_base_widgets)






add_library(kmm_widgets ${kmm_widgets_SOURCES})

target_link_libraries(kmm_widgets PUBLIC
  KF${QT_MAJOR_VERSION}::TextWidgets
  KF${QT_MAJOR_VERSION}::KIOWidgets
  KF${QT_MAJOR_VERSION}::Completion
  KF${QT_MAJOR_VERSION}::Notifications
  KF${QT_MAJOR_VERSION}::ItemViews
  KF${QT_MAJOR_VERSION}::I18n
  KF${QT_MAJOR_VERSION}::XmlGui
  KF${QT_MAJOR_VERSION}::ConfigWidgets
  KF${QT_MAJOR_VERSION}::ConfigCore
  KF${QT_MAJOR_VERSION}::ItemModels
  KF${QT_MAJOR_VERSION}::Service
  Qt::Gui
  Qt::Core
  Qt::Widgets
  Qt::Xml
  Alkimia::alkimia
  converter
  kmm_mymoney
  kmm_models
  kmm_plugin
  kmm_settings
  kmm_base_dialogs
  kmm_base_widgets
  kmm_selections
  kmm_utils_platformtools
)

set_target_properties(kmm_widgets PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR}
)
#   COMPILE_FLAGS "-DKMM_BUILD_WIDGETS_LIB"

generate_export_header(kmm_widgets BASE_NAME kmm_widgets)

########### install files ###############
install(TARGETS kmm_base_widgets kmm_widgets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES ${kmm_widgets_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/kmm_widgets_export.h
  DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kmymoney COMPONENT Devel)

############## tests ####################

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== kmymoney/converter/tests/CMakeLists.txt ===
include(ECMAddTests)

file(GLOB tests_sources "*-test.cpp")
kmm_add_tests(${tests_sources}
  LINK_LIBRARIES
    Qt::Core
    Qt::Test
    kmm_testutils
    kmm_testutilities
    converter
)

=== kmymoney/dialogs/settings/CMakeLists.txt ===

set (libsettings_a_SOURCES
  ksettingscolors.cpp
  ksettingsfonts.cpp
  ksettingsicons.cpp
  ksettingsgeneral.cpp
  ksettingshome.cpp
  ksettingsonlinequotes.cpp
  ksettingsregister.cpp
  ksettingsschedules.cpp
  ksettingskmymoney.cpp
  ksettingsplugins.cpp
  )

set (libsettings_a_UI
  ksettingscolors.ui
  ksettingsfonts.ui
  ksettingsicons.ui
  ksettingsgeneral.ui
  ksettingshome.ui
  ksettingsonlinequotes.ui
  ksettingsregister.ui
  ksettingsschedules.ui
  )

ki18n_wrap_ui(libsettings_a_SOURCES ${libsettings_a_UI} )

add_library(settings STATIC ${libsettings_a_SOURCES})

# TODO: cleanup dependencies
target_link_libraries(settings PUBLIC
  KF${QT_MAJOR_VERSION}::Completion
  KF${QT_MAJOR_VERSION}::KIOWidgets
  KF${QT_MAJOR_VERSION}::TextWidgets
  KF${QT_MAJOR_VERSION}::I18n
  KF${QT_MAJOR_VERSION}::Completion
  KF${QT_MAJOR_VERSION}::KCMUtils
  KF${QT_MAJOR_VERSION}::ItemViews
  Alkimia::alkimia
)

if (ENABLE_HOLIDAYS)
  target_link_libraries(settings PUBLIC KF${QT_MAJOR_VERSION}::Holidays)
endif()

add_dependencies(settings kmm_widgets kmm_settings)

=== kmymoney/mymoney/storage/CMakeLists.txt ===
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

set(storage_HEADERS
  imymoneystorageformat.h
  mymoneymodelbase.h
  mymoneymodel.h
  payeesmodel.h
  costcentermodel.h
  schedulesmodel.h
  tagsmodel.h
  securitiesmodel.h
  budgetsmodel.h
  accountsmodel.h
  institutionsmodel.h
  journalmodel.h
  pricemodel.h
  parametersmodel.h
  onlinejobsmodel.h
  reportsmodel.h
  reconciliationmodel.h
  )

########### install files ###############

install(FILES ${storage_HEADERS}
  DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kmymoney COMPONENT Devel )

=== kmymoney/mymoney/tests/CMakeLists.txt ===
include(ECMAddTests)

add_library(kmm_testutils STATIC mymoneytestutils.cpp)
target_link_libraries(kmm_testutils
  PUBLIC
    Qt::Core
    kmm_mymoney
)

file(GLOB tests_sources "*-test.cpp")
kmm_add_tests(${tests_sources}
  LINK_LIBRARIES
    Qt::Core
    Qt::Test
    Qt::Xml
    Qt::Gui
    kmm_mymoney
    kmm_testutils
    kmm_testutilities
    onlinetask_interfaces
)

=== debian/changelog ===
kmymoney (5.2.1-1~exp1) experimental; urgency=medium

  * Team upload.

  [ Boyuan Yang ]
  * New upstream release.
  * debian/control: Switch to Qt6 and KF6. (Closes: #1111397)
  * debian/watch: Fix upstream monitoring script.
  * debian/*.install: Updated accordingly.

 -- Boyuan Yang <byang@debian.org>  Fri, 14 Nov 2025 14:46:53 -0500

=== debian/control ===
Source: kmymoney
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
 cmake (>= 3.12.0~),
 pkg-kde-tools (>= 0.15.16),
 gettext,
 extra-cmake-modules (>= 5.42.0~),
 libcups2-dev,
 libkchart2-dev (>= 2.6.0~),
 libkf6archive-dev,
 libkf6coreaddons-dev,
 libkf6config-dev,
 libkf6configwidgets-dev,
 libkf6crash-dev,
 libkf6i18n-dev,
 libkf6completion-dev,
 libkf6kcmutils-dev,
 libkf6itemmodels-dev,
 libkf6itemviews-dev,
 libkf6service-dev,
 libkf6xmlgui-dev,
 libkf6textwidgets-dev,
 libkf6notifications-dev,
 libkf6kio-dev,
 libplasmaactivities-dev,
 libkf6doctools-dev,
 libkf6holidays-dev,
 libkf6contacts-dev,
 libakonadi-dev,
 libkidentitymanagement-dev,
 libqgpgmeqt6-dev,
 python3-dev,
 qtkeychain-qt6-dev,
 qt6-base-dev,
 qt6-webengine-dev,
 qt6-svg-dev,
 libaqbanking-dev (>= 6.0.1~),
 libgwenhywfar-core-dev (>= 5.1.2~),
 libgpgmepp-dev, libgpg-error-dev, libgpgme-dev,
 libalkimia6-dev (>= 5.2.1~),
 libical-dev (>= 3.0.11-2~),
 libofx-dev, libgmp-dev,
 libsqlcipher-dev,
 libsqlite3-dev,
 pkgconf,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://kmymoney.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kmymoney
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kmymoney.git

Package: kmymoney
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, kmymoney-common (= ${source:Version})
Recommends: gpg-agent, pinentry-qt | pinentry-x11
Suggests: kcalc
Description: personal finance manager for KDE
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.

Package: kmymoney-common
Architecture: all
Depends: ${misc:Depends},
 ${perl:Depends},
Recommends: kmymoney,
 libfinance-quote-perl,
Description: KMyMoney architecture independent files
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.
 .
 This package contains architecture independent files needed for KMyMoney to
 run properly. It also provides KMyMoney documentation. Therefore, unless you
 have 'kmymoney' package installed, you will hardly find this package useful.

=== debian/rules ===
#!/usr/bin/make -f

# lots of deprecation warnings, so disable them for now
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-deprecated -Wno-deprecated-declarations

%:
	dh $@ --with kf6

override_dh_auto_configure:
	dh_auto_configure -Skf6 -- -DCMAKE_SKIP_RPATH=ON -DBUILD_TESTING=OFF -DENABLE_WEBENGINE=ON -DBUILD_WITH_QT6=ON

execute_after_dh_auto_install:
	# remove development stuff
	rm -rf debian/tmp/usr/include/
	find debian/tmp -name '*.so' -type l -delete

.PHONY: override_dh_auto_test

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
https://download.kde.org/stable/kmymoney/([\d\.]+)/kmymoney-([\d\.]+)\.tar\.xz

## kmymoney 5.2.1+p24.04+vstable+git20251012.0158

=== debian/changelog ===
kmymoney (5.2.1+p24.04+vstable+git20251012.0158-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 12 Oct 2025 01:58:56 +0000

kmymoney (5.2.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 18 Aug 2025 00:12:12 +0000

kmymoney (5.2.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 08 Jul 2025 00:20:58 +0000

## kmymoney 5.2.1+p24.04+vstable+git20251015.1738

=== debian/changelog ===
kmymoney (5.2.1+p24.04+vstable+git20251015.1738-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 17:38:13 +0000

## kmymoney 5.2.1+p24.04+vstable+git20251025.0018

=== debian/changelog ===
kmymoney (5.2.1+p24.04+vstable+git20251025.0018-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 25 Oct 2025 00:18:42 +0000

## kmymoney 5.2.1+p24.04+vstable+git20251030.0021

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2022 Alexander Lohnau <alexander.lohnau@gmx.de>

# For all the configurable CMake switches, please see https://invent.kde.org/office/kmymoney/-/wikis/home#cmake-switches

# The CMake version we require
cmake_minimum_required(VERSION 3.16)

option(BUILD_STATIC_PLUGINS "Build the plugins statically" OFF)

set(KF6_MIN_VERSION 6.1)
set(KF5_MIN_VERSION 5.90)
set(QT6_MIN_VERSION 6.7)
set(QT5_MIN_VERSION 5.15.2)
set(KDE5_MIN_LEVEL 5.82)
set(KDE6_MIN_LEVEL ${KF6_MIN_VERSION})

# adds option BUILD_WITH_QT6
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
include(QtVersionOption)
set(KF_MIN_VERSION ${KF${QT_MAJOR_VERSION}_MIN_VERSION})
set(QT_MIN_VERSION ${QT${QT_MAJOR_VERSION}_MIN_VERSION})
set(KDE_COMPILERSETTINGS_LEVEL ${KDE${QT_MAJOR_VERSION}_MIN_LEVEL})

if (NOT BUILD_STATIC_PLUGINS)
    set(AKONADI_MIN_VERSION 5.14.2)
    if(BUILD_WITH_QT6)
        set(AKONADI_MIN_VERSION 6.0.0)
    endif()
endif()


set(RELEASE_SERVICE_VERSION_MAJOR "5")
set(RELEASE_SERVICE_VERSION_MINOR "2")
set(RELEASE_SERVICE_VERSION_MICRO "1")
set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

# Use ccache if available
find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
endif()

# Setting the name of the main project
project(KMyMoney VERSION "${RELEASE_SERVICE_VERSION}" LANGUAGES CXX)

# Minimum versions required for extern packages
set(KMM_ALKIMIA_MIN_VERSION 8.2.1)
set(KMM_KCHART_MIN_VERSION 2.6.0)
# LibOFX uses two different version numbers. find_package looks for the
# library's so version whereas pkg_check_modules retrieves the package
# version. Details can be found in the libofx source code
set(KMM_LIBOFX_MIN_VERSION 0.10.0)
set(KMM_LIBOFX_MIN_SOVERSION 7.0.0)
set(KMM_AQBANKING_MIN_VERSION 6.6.1)
set(KMM_GWENHYWFAR_MIN_VERSION 5.12.1)

# Determine the GIT reference (if we're based on GIT)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  execute_process(COMMAND git rev-parse --short HEAD
          WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
          OUTPUT_VARIABLE VERSION_SUFFIX
          OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(VERSION_SUFFIX "-${VERSION_SUFFIX}")
  # Add variables which are similar to the build in names of cmake
  set(PROJECT_VERSION_SUFFIX "${VERSION_SUFFIX}")
  set(${PROJECT_NAME}_VERSION_SUFFIX "${VERSION_SUFFIX}")
elseif(DEFINED VERSION_SUFFIX)
  string(REGEX REPLACE "-*(.+)" "\\1" DASHFREE_SUFFIX "${VERSION_SUFFIX}")
  set(PROJECT_VERSION_SUFFIX "-${DASHFREE_SUFFIX}")
  set(${PROJECT_NAME}_VERSION_SUFFIX "-${DASHFREE_SUFFIX}")
endif()

if (POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW) # Policy introduced in CMake version 3.3
endif()
if (POLICY CMP0127)
  cmake_policy(SET CMP0127 NEW) # Policy introduced in CMake version 3.22
endif()

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

######################### General Requirements ##########################

if (CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0.0)
    message(FATAL_ERROR "This version of KMyMoney requires at least gcc 6.0.0 to be built successfully")
endif()

# To build shared libraries in Windows, we set CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS to TRUE.
# See https://cmake.org/cmake/help/v3.4/variable/CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS.html
# See https://blog.kitware.com/create-dlls-on-windows-without-declspec-using-new-cmake-export-all-feature/
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

set(APPLE_SUPPRESS_X11_WARNING TRUE)

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
include(KDEInstallDirs)
include(KDECMakeSettings)

include(FeatureSummary)
include(CMakeDependentOption)

include(GenerateExportHeader)
include(KMyMoneyMacros)
set(KMM_ADD_TESTS_ENVIRONMENT "LANG=C.UTF-8")

include(KDEGitCommitHooks)
kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

if(BUILD_WITH_QT6)
    message(WARNING
      "This is the first release with Qt6/KF6 support."
      " If you find an error, please open a bug report at"
      " https://bugs.kde.org/enter_bug.cgi?product=kmymoney."
    )
    # allow QString("...")
    add_definitions(
        -UQT_NO_CAST_FROM_ASCII
        -UQT_NO_CAST_FROM_BYTEARRAY
        -UQT_NO_CAST_TO_ASCII
        -UQT_NO_CAST_TO_BYTEARRAY
    )
endif()

add_definitions(
    -DKF_DEPRECATED_WARNINGS_SINCE=0x60000
    -DKF_DISABLE_DEPRECATED_BEFORE_AND_AT=0x56200C
    -DQT_DEPRECATED_WARNINGS_SINCE=0x60000
    -DQT_DISABLE_DEPRECATED_BEFORE=0x50f02
)

message(STATUS "cmake version: ${CMAKE_VERSION}")

# GPG Encryption checks
# ---------------------
set(GPG_FOUND FALSE)
if(BUILD_WITH_QT6)
    find_package(QGpgmeQt6)
    if(QGpgmeQt6_FOUND)
        set(GPG_FOUND TRUE)
        set(GPG_DIR ${QGpgmeQt6_DIR})
        set(GPG_LIBRARY QGpgmeQt6)
        set(GPG_VERSION ${QGpgmeQt6_VERSION})
    endif()
else()
    find_package(QGpgme)
    if (QGpgme_FOUND)
        set(GPG_FOUND TRUE)
        set(GPG_DIR ${QGpgme_DIR})
        set(GPG_LIBRARY QGpgme)
        set(GPG_VERSION ${QGpgme_VERSION})
    else()
        find_package(Gpgmepp)
        if (Gpgmepp_FOUND)
            set(GPG_FOUND TRUE)
            set(GPG_DIR ${Gpgmepp_DIR})
            set(GPG_LIBRARY Gpgmepp)
            set(GPG_VERSION ${Gpgmepp_VERSION})
        endif()
    endif()
endif()
if(GPG_FOUND)
    message(STATUS "Found GPG: ${GPG_DIR} (version \"${GPG_VERSION}\")")
    find_path(GPGMEPP_HEADER_DIR "gpgme++/error.h" ${CMAKE_SYSTEM_INCLUDE_PATH})
    file(READ "${GPGMEPP_HEADER_DIR}/gpgme++/error.h" GPGMEPP_ERROR_H_CONTENT)
    string(FIND "${GPGMEPP_ERROR_H_CONTENT}" "std::string asStdString() const" FOUND_AS_STD_STRING)
    set(HAVE_GPGMEPP_AS_STD_STRING FALSE)
    if (${FOUND_AS_STD_STRING} GREATER 0)
        set(HAVE_GPGMEPP_AS_STD_STRING TRUE)
        message(STATUS "Found GpgME::Error::asStdString")
    endif()
endif()

cmake_dependent_option(ENABLE_GPG "Enable GPG support." ON
                       "GPG_FOUND" OFF)

add_feature_info("Encryption" ENABLE_GPG "Allows to store your financial data using strong GPG encryption.")





find_package(PkgConfig)
if (PkgConfig_FOUND)
  pkg_check_modules(SQLCIPHER sqlcipher IMPORTED_TARGET)
endif()

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED COMPONENTS Core DBus Widgets Svg Xml Test PrintSupport)
find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} OPTIONAL_COMPONENTS Sql Concurrent QuickWidgets)

if (Qt6Sql_VERSION VERSION_GREATER_EQUAL "6.10.0")
  find_package(Qt6 REQUIRED COMPONENTS SqlPrivate)
endif()

find_package(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS Archive CoreAddons Config ConfigWidgets Crash I18n Completion KCMUtils ItemModels ItemViews Service XmlGui TextWidgets Notifications KIO)

# For KF < 5.100 we need to fix a few method names that
# have been deprecated but are not available before that version.
# Once the KF_MIN_VERSION of this project is >= 5.100 this
# whole block can be removed
if (${KF_MIN_VERSION} VERSION_LESS "5.100")
    if (${KF5_VERSION} VERSION_LESS "5.100")
        add_definitions(
            -DquestionTwoActions=questionYesNo
            -DquestionTwoActionsCancel=questionYesNoCancel
            -DwarningTwoActions=warningYesNo
            -DwarningTwoActionsCancel=warningYesNoCancel
            -DPrimaryAction=Yes
            -DSecondaryAction=No
        )
    endif()
elseif(NOT BUILD_WITH_QT6)
    message(FATAL_ERROR "Remove the above logic from CMakeLists.txt since it is not needed anymore")
endif()

if(BUILD_WITH_QT6)
    find_package(PlasmaActivities)
else()
    set(KF_ACTIVITIES Activities)
endif()
find_package(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} OPTIONAL_COMPONENTS DocTools Holidays Contacts ${KF_ACTIVITIES})
if (DEFINED AKONADI_MIN_VERSION)
  # Akonadi 23.04 moved to KPim5 prefix, deprecating KF5
  set(PIMPREFIX KPim${QT_MAJOR_VERSION})
  find_package(${PIMPREFIX}Akonadi ${AKONADI_MIN_VERSION} QUIET)
  if(NOT ${PIMPREFIX}Akonadi_FOUND)
    set(PIMPREFIX KF${QT_MAJOR_VERSION})
    find_package(${PIMPREFIX}Akonadi ${AKONADI_MIN_VERSION} QUIET)
  endif()
  if(${PIMPREFIX}Akonadi_FOUND)
    # for config-kmymoney.h.cmake
    set(ADDRESSBOOK_VERSION ${${PIMPREFIX}Akonadi_VERSION})
  endif()
  if(AKONADI_MIN_VERSION VERSION_GREATER_EQUAL "6.0.0")
    find_package(${PIMPREFIX}IdentityManagementCore ${AKONADI_MIN_VERSION} QUIET)
  else()
    find_package(${PIMPREFIX}IdentityManagement ${AKONADI_MIN_VERSION} QUIET)
  endif()
endif()

find_package(Qt${QT_MAJOR_VERSION}Keychain CONFIG REQUIRED)

if(LibAlkimia${QT_MAJOR_VERSION}_DIR)
  set(_LibAlkimia${QT_MAJOR_VERSION}_DIR ${LibAlkimia${QT_MAJOR_VERSION}_DIR})
endif()
find_package(LibAlkimia${QT_MAJOR_VERSION} ${KMM_ALKIMIA_MIN_VERSION} REQUIRED)
if (NOT LibAlkimia${QT_MAJOR_VERSION}_FOUND)
  # restore LibAlkimia5_DIR set to NOTFOUND by first find_package call
  if(_LibAlkimia${QT_MAJOR_VERSION}_DIR)
    set(LibAlkimia${QT_MAJOR_VERSION}_DIR ${_LibAlkimia${QT_MAJOR_VERSION}_DIR})
  endif()
  find_package(LibAlkimia${QT_MAJOR_VERSION} 8.1 REQUIRED)
endif()

if(BUILD_WITH_QT6)
    find_package(KChart6 ${KMM_KCHART_MIN_VERSION} QUIET)
else()
    find_package(KChart ${KMM_KCHART_MIN_VERSION} QUIET)
endif()

# we want the lowercase 'libofx' package name, for 'libofx_FOUND' compatibility with what pkg-config returns,
# in case it is to be used as fallback
find_package(libofx ${KMM_LIBOFX_MIN_SOVERSION} NAMES LibOFX libofx)
if(NOT libofx_FOUND)
    find_package(PkgConfig)

    if(PkgConfig_FOUND)
        pkg_check_modules(libofx IMPORTED_TARGET libofx)

        if(libofx_FOUND)
            if (${libofx_VERSION} VERSION_GREATER_EQUAL ${KMM_LIBOFX_MIN_VERSION})
                set(libofx_FOUND TRUE)
                add_library(libofx::libofx INTERFACE IMPORTED)
                target_link_libraries(libofx::libofx INTERFACE PkgConfig::libofx)
                message(STATUS "Version ${libofx_VERSION} of libofx found and is larger than the required version ${KMM_LIBOFX_MIN_VERSION}")
            else()
                message(STATUS "Version ${libofx_VERSION} of libofx does not meet min. required version ${KMM_LIBOFX_MIN_VERSION}")
                set(libofx_FOUND FALSE)
            endif()
        endif()
    endif()
endif()


add_definitions(-DQT_USE_QSTRINGBUILDER -DQT_NO_CAST_TO_ASCII -DQT_NO_URL_CAST_FROM_STRING -DQT_NO_KEYWORDS)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# use DBus only on Linux
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(KMM_DBUS 1)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})

# check for Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
  set(APIDOC_DIR ${CMAKE_CURRENT_BINARY_DIR}/apidocs)

  make_directory("${APIDOC_DIR}")
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/kmymoney.doxygen.in ${CMAKE_CURRENT_BINARY_DIR}/kmymoney.doxygen IMMEDIATE)

  add_custom_target(apidoc "${DOXYGEN}" "${CMAKE_CURRENT_BINARY_DIR}/kmymoney.doxygen")
endif(DOXYGEN_FOUND)
add_feature_info("Doxygen" DOXYGEN_FOUND "Generate API documentation with Doxygen (for devs only).")

# check some include files exists
set(CMAKE_REQUIRED_DEFINITIONS -D_XOPEN_SOURCE=500 -D_BSD_SOURCE)
include (CheckIncludeFileCXX)
check_include_file_cxx("unistd.h" HAVE_UNISTD_H)
check_include_file_cxx("pwd.h" HAVE_PWD_H)
check_include_file_cxx("windows.h" HAVE_WINDOWS_H)
check_include_file_cxx("lmcons.h" HAVE_LMCONS_H)
check_include_file_cxx("process.h" HAVE_PROCESS_H)

# include check for members in structs
include (CheckStructHasMember)

######################### Special Requirements ##########################

if(QT_MAJOR_VERSION LESS 6)
  # This is needed for QtSqlite and QtDesigner
  # (they'll install files to ${QT_INSTALL_DIR}/plugins/)
  get_filename_component(QT_BIN_DIR "${QT_MOC_EXECUTABLE}" PATH)
  get_filename_component(QT_DIR     ${QT_BIN_DIR}        PATH)
  set(QT_INSTALL_DIR ${QT_DIR} CACHE PATH

=== debian/changelog ===
kmymoney (5.2.1+p24.04+vstable+git20251030.0021-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 30 Oct 2025 00:21:14 +0000

## kmymoney 5.2.1+p24.04+vstable+git20251031.1018

=== debian/changelog ===
kmymoney (5.2.1+p24.04+vstable+git20251031.1018-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 31 Oct 2025 10:18:23 +0000

## kmymoney 5.2.1+p24.04+vstable+git20251231.0301

=== debian/changelog ===
kmymoney (5.2.1+p24.04+vstable+git20251231.0301-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 31 Dec 2025 03:01:38 +0000

## kmymoney 5.2.1+p24.04+vstable+git20260101.0148

=== debian/changelog ===
kmymoney (5.2.1+p24.04+vstable+git20260101.0148-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 01 Jan 2026 01:48:18 +0000

## kmymoney 5.2.1+p24.04+vstable+git20260202.1058

=== CMakeLists.txt ===
--- 
+++ 
@@ -51,8 +51,8 @@
 # version. Details can be found in the libofx source code
 set(KMM_LIBOFX_MIN_VERSION 0.10.0)
 set(KMM_LIBOFX_MIN_SOVERSION 7.0.0)
-set(KMM_AQBANKING_MIN_VERSION 6.6.1)
-set(KMM_GWENHYWFAR_MIN_VERSION 5.12.1)
+set(KMM_AQBANKING_MIN_VERSION 6.8.4)
+set(KMM_GWENHYWFAR_MIN_VERSION 5.14.1)
 
 # Determine the GIT reference (if we're based on GIT)
 if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
@@ -60,7 +60,17 @@
           WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
           OUTPUT_VARIABLE VERSION_SUFFIX
           OUTPUT_STRIP_TRAILING_WHITESPACE)
-  set(VERSION_SUFFIX "-${VERSION_SUFFIX}")
+  execute_process(COMMAND git tag --contains ${VERSION_SUFFIX}
+          WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
+          OUTPUT_VARIABLE TAG
+          OUTPUT_STRIP_TRAILING_WHITESPACE)
+  # for commits that don't have a tag add the commit hash
+  # don't add the hash if the commit is tagged
+  if("" STREQUAL "${TAG}")
+    set(VERSION_SUFFIX "-${VERSION_SUFFIX}")
+  else()
+    set(VERSION_SUFFIX "")
+  endif()
   # Add variables which are similar to the build in names of cmake
   set(PROJECT_VERSION_SUFFIX "${VERSION_SUFFIX}")
   set(${PROJECT_NAME}_VERSION_SUFFIX "${VERSION_SUFFIX}")
@@ -287,6 +297,12 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
+# freeBSD error: passing no argument for the '...' parameter of a
+# variadic macro is a C++20 extension [-Werror,-Wc++20-extensions]
+if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    add_compile_options(-Wno-c++20-extensions)
+endif()
+
 # use DBus only on Linux
 if(CMAKE_SYSTEM_NAME MATCHES "Linux")
   set(KMM_DBUS 1)
@@ -312,18 +328,3 @@
 include (CheckIncludeFileCXX)
 check_include_file_cxx("unistd.h" HAVE_UNISTD_H)
 check_include_file_cxx("pwd.h" HAVE_PWD_H)
-check_include_file_cxx("windows.h" HAVE_WINDOWS_H)
-check_include_file_cxx("lmcons.h" HAVE_LMCONS_H)
-check_include_file_cxx("process.h" HAVE_PROCESS_H)
-
-# include check for members in structs
-include (CheckStructHasMember)
-
-######################### Special Requirements ##########################
-
-if(QT_MAJOR_VERSION LESS 6)
-  # This is needed for QtSqlite and QtDesigner
-  # (they'll install files to ${QT_INSTALL_DIR}/plugins/)
-  get_filename_component(QT_BIN_DIR "${QT_MOC_EXECUTABLE}" PATH)
-  get_filename_component(QT_DIR     ${QT_BIN_DIR}        PATH)
-  set(QT_INSTALL_DIR ${QT_DIR} CACHE PATH

=== kmymoney/plugins/views/reports/core/tests/data/CMakeLists.txt ===
set(infotable_test_files
  test-general-information.xml
)

set(querytable_test_files
  test-382245.xml
  test-423870.xml
  test-424674.xml
  test-448788.xml
  test-453033.xml
  test-469195.xml
  test-cash-flow.xml
  test-investment.xml
  test-net-worth.xml
  test-transactions.xml
  refinance-loan.xml
)

set(pivottable_test_files
  test-income-and-expenses.xml
  test-net-worth.xml
  test-pivottable.xml
  test-closed-account.xml
)

macro(fetch_report_names file)
  set(options)
  set(oneValueArgs)
  set(multiValueArgs RETURN_NAMES RETURN_TYPES RETURN_IDS)
  cmake_parse_arguments(FRN "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  set(${FRN_RETURN_NAMES})
  set(${FRN_RETURN_TYPES})
  set(${FRN_RETURN_IDS})
  file(STRINGS
    ${file} lines
    REGEX ".*<REPORT .*"
    ENCODING UTF-8
  )
  foreach(line ${lines})
    string(REGEX REPLACE "<REPORT (.*)[/]?>" "\\1" l ${line})
    #message( "++++ ${l}")
    string(REGEX REPLACE " ([a-zA-Z0-9]+=)" ";\\1" attributes ${l})
    foreach(m ${attributes})
      if (m MATCHES "^name=\"(.*)\"")
        list(APPEND ${FRN_RETURN_NAMES} ${CMAKE_MATCH_1})
      endif()
      if (m MATCHES "^type=\"(.*)\"")
        list(APPEND ${FRN_RETURN_TYPES} ${CMAKE_MATCH_1})
      endif()
      if (m MATCHES "^id=\"(.*)\"")
          list(APPEND ${FRN_RETURN_IDS} ${CMAKE_MATCH_1})
      endif()
    endforeach()
  endforeach()
endmacro()

macro(to_test_and_file_name)
  set(options)
  set(oneValueArgs TYPE BASENAME REPORT_NAME)
  set(multiValueArgs RETURN_TEST_NAME RETURN_FILE_NAME)
  cmake_parse_arguments(TTAFN "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  string(REGEX REPLACE "[ .]" "-" _rn ${TTAFN_REPORT_NAME})
  string(REGEX REPLACE "[^. a-zA-Z0-9_-]" "_" _rn ${_rn})
  set(${TTAFN_RETURN_TEST_NAME} reports-${TTAFN_TYPE}-${TTAFN_BASENAME}-${_rn})
  set(${TTAFN_RETURN_FILE_NAME} ${TTAFN_BASENAME}-report-${TTAFN_TYPE}-${_rn})
endmacro()

macro(add_report_tests)
   set(options)
   set(oneValueArgs TYPE)
   set(multiValueArgs FILES FORMATS)
   cmake_parse_arguments(ART "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  foreach(file ${ART_FILES})
    cmake_path(GET file STEM basename)
    message(STATUS "${file}")
    fetch_report_names(${file} RETURN_NAMES report_names RETURN_TYPES report_types RETURN_IDS report_ids)
    set(i 0)
    list(LENGTH report_names j)
    while(i LESS j)
      list(GET report_names ${i} rn)
      list(GET report_types ${i} rt)
      list(GET report_ids ${i} id)
      math(EXPR i "${i} + 1")
      if(NOT rt MATCHES "${ART_TYPE}.*")
        continue()
      endif()
      foreach(format ${ART_FORMATS})
        to_test_and_file_name(TYPE ${ART_TYPE} BASENAME ${basename} REPORT_NAME ${rn} RETURN_TEST_NAME test_name RETURN_FILE_NAME file_name)
        message(" * adding test '${test_name}-${format}' for report '${rn}' with type '${rt}' and id '${id}'")
        add_test(
          NAME ${test_name}-${format}
          COMMAND ${CMAKE_COMMAND}
            -Dlauncher=$<TARGET_FILE:kmmreport-export>
            -Dtestfile=${CMAKE_CURRENT_SOURCE_DIR}/${file}
            -Dformat=${format}
            -Dtype=${ART_TYPE}
            -Dreport=${rn}
            -Doutfilename=${CMAKE_CURRENT_BINARY_DIR}/${file_name}.${format}
            -Dreffilename=${CMAKE_CURRENT_SOURCE_DIR}/${file_name}.${format}
            -Dworkingdir=${CMAKE_CURRENT_BINARY_DIR}
            -P ${CMAKE_CURRENT_SOURCE_DIR}/compare.cmake
        )
        set_tests_properties(${test_name}-${format}
          PROPERTIES
            SKIP_REGULAR_EXPRESSION "is missing" "SKIP" "Skipped"
            ENVIRONMENT ${KMM_ADD_TESTS_ENVIRONMENT}
          )
      endforeach()
    endwhile()
  endforeach()
endmacro()

add_report_tests(TYPE infotable FILES ${infotable_test_files} FORMATS csv)
add_report_tests(TYPE querytable FILES ${querytable_test_files} FORMATS csv)
add_report_tests(TYPE pivottable FILES ${pivottable_test_files} FORMATS csv)

=== debian/changelog ===
kmymoney (5.2.1+p24.04+vstable+git20260202.1058-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 02 Feb 2026 10:58:27 +0000
